<cfscript>
	function bindFunction( func, context ) {
		getMetaData(func).context = context;
		return func;
	}
	
	function applyFunction( func ) {
		var metaData = getMetaData(func);
		var context = metaData.context;
		var args = structNew();
		
		if( structCount(arguments) gt 1 )
			args = arguments[2];
		
		if( structCount(arguments) gt 2 )
			context = arguments[3];
		
		args.variables = context;
		args.metadata = getMetaData(func);
		
		return func( argumentCollection=args );
	}
	
	function test( variables ) {
		writeOutput( variables.foo );
	}
	
	foo = "hello";
	
	bindFunction( test, variables );
	
	applyFunction( test );
</cfscript>