<!---
We can also use functions as iterators instead of tag bodies. Sometimes this is MUCH more concise to implement and use. Also allows reuse of the inner strategy.
--->

<t:Comments entry="#entry#" iterator="#comment_iter#">
<cffunction name="comment_iter">
	<cfargument name="comment">
	<cfargument name="variables">
	
	<cfset var classes = "">
	
	<cfif variables.user.getId() eq comment.getId()>
		<cfset classes &= "current-user">
	</cfif>
	
	<cfoutput>
		<div class="#classes#">
			<h2>#comment.getTitle()#</h2>
 			<p>#comment.getBody()#</p>
		</div>
	</cfoutput>
</cffunction>
</t:Comments>

<t:Comments entry="#entry#" item="comment">
	<cfset classes = "">
	
	<cfif variables.user.getId() eq comment.getId()>
		<cfset classes &= "current-user">
	</cfif>
	
	<cfoutput>
		<div class="#classes#">
			<h2>#comment.getTitle()#</h2>
 			<p>#comment.getBody()#</p>
		</div>
	</cfoutput>
</t:Comments>

<!--- Implementation??? --->

<cfloop array="#attributes.entry.getComments()#" index="comment">
	<cfset attributes.iterator( comment, caller.variables )>
</cfloop>
<cfexit>

<!--- OR --->

<cfif thisTag.executionMode eq "start">
	<cfset thisTag.position = 1>
	<cfset thisTag.comments = attributes.entry.getComments()>
	
	<cfif not arrayLen(thisTag.comments)>
		<cfexit>
	</cfif>
	
	<cfset caller[attributes.item] = thisTag.comments[1]>
<cfelse>
	<cfif arrayLen(thisTag.comments) eq thisTag.position)>
		<cfexit>
	</cfif>
	
	<cfset thisTag.position += 1>
	
	<cfset caller[attributes.item] = thisTag.comments[thisTag.position]>
	<cfexit method="loop">
</cfif>

<!--- DO: Calendar example code to really show this off as weird => concise with function ptrs. -->