<cfset car = createObject("component","Car").init()>
<cfset car.setMaker("Nissan")>
<cfset car.setModel("240sx")>
<cfset car.setYear(1992)>

<cfset bcar = createObject("component","BetterCar").init()>
<cfset bcar.setPrototype(car)>

<cftimer label="Prototype Object Create">
	<cfloop from="1" to="100" index="i">
		<cfset myCar = bcar.new()>
	</cfloop>
</cftimer>

<cfdump var="#myCar.getDescription()#">

<hr>

<cfscript>
	function car_getId() {
		return hash(this.getYear() & this.getModel() & this.getMaker());
	}
</cfscript>

<cfset proto = createObject("component","prototype.Prototype").init()>
<cfset proto.getId = car_getId>
<cfset car.setPrototype(proto)>

<!--- bcar .. car .. proto --->
<cfdump var="#myCar.getId()#">

<cftimer label="Regular Object Create">
	<cfloop from="1" to="100" index="i">
		<cfset myCar = createObject("component","FBetterCar").init()>
	</cfloop>
</cftimer>

