<cfset user = createObject("component","User").init()>
<cfset admin = createObject("component","Admin").init()>
<cfset admin.setPrototype(user)>

<cfset me = admin.new()>
<cfset me.setName("Elliott Sprehn")>
<cfset me.setEmail("elliott@teratech.com")>

<!--- Somewhere off in plugin land... --->
<cfscript>
	function toXML() {
		return "
			<user id='#this.getId()#'>
				<name>#this.getName()#</name>
				<email>#this.getEmail()#</email>
			</user>";
	}
</cfscript>
<cfset user.toXML = toXML>

<cfset writeOutput( me.toXML() )>
<!---
	<user id="1">
		<name>Elliott Sprehn</name>
		<email>elliott@teratech.com</email>
	</user>
--->