<cfcomponent output="false">

	<cfset metadata = getMetaData(this)>
	
	<cfif not structKeyExists(metadata,"static")>
		<cflock name="StaticVariables(#metadata.name#)" timeout="10">
			<cfif not structKeyExists(metadata,"static")>
				<cfset metadata.static = {
					instance = ""
				}>
			</cfif>
		</cflock>
	</cfif>
	
	<cffunction name="init" access="public" returntype="any" output="false">
		
		<cfset var static = getMetaData(this).static>
		
		<cfif not isObject(static.instance)>
			<cflock timeout="30" name="Singleton(#getMetaData(this).name#)">
				<cfif not isObject(static.instance)>
					<cfset static.instance = this>
				</cfif>
			</cflock>
		</cfif>
		
		<!--- Init Code --->
		
		<cfreturn static.instance>
	</cffunction>
	
</cfcomponent>

